--- /tmp/alsa-info-working.txt	2011-02-08 15:23:30.000000000 +0100
+++ /tmp/alsa-info-notworking.txt	2011-02-08 15:23:37.000000000 +0100
@@ -3,7 +3,7 @@
 !!ALSA Information Script v 0.4.60
 !!################################
 
-!!Script ran on: Tue Feb  8 06:44:02 UTC 2011
+!!Script ran on: Tue Feb  8 06:54:04 UTC 2011
 
 
 !!Linux Distribution
@@ -15,15 +15,15 @@
 !!DMI Information
 !!---------------
 
-Manufacturer:      
-Product Name:      
-Product Version:   
+Manufacturer:                                      
+Product Name:                                      
+Product Version:                           
 
 
 !!Kernel Information
 !!------------------
 
-Kernel release:    2.6.36-itx
+Kernel release:    2.6.37-itx
 Operating System:  GNU/Linux
 Architecture:      i686
 Processor:         Intel(R) Core(TM) i3 CPU 550 @ 3.20GHz
@@ -60,6 +60,8 @@
 
  0 [Intel          ]: HDA-Intel - HDA Intel
                       HDA Intel at 0xf0420000 irq 22
+ 1 [Q9000          ]: USB-Audio - QuickCam Pro 9000
+                      Logitech, Inc. QuickCam Pro 9000 at usb-0000:00:1a.0-1.1, high speed
 
 
 !!PCI Soundcards installed in the system
@@ -101,19 +103,19 @@
   IO[1]: enable=0, dir=0, wake=0, sticky=0, data=0, unsol=0
 Node 0x02 [Audio Output] wcaps 0x11: Stereo
   Device: name="ALC889 Analog", type="Audio", device=0
-  Converter: stream=5, channel=0
+  Converter: stream=0, channel=0
   PCM:
     rates [0x5e0]: 44100 48000 88200 96000 192000
     bits [0xe]: 16 20 24
     formats [0x1]: PCM
 Node 0x03 [Audio Output] wcaps 0x11: Stereo
-  Converter: stream=5, channel=2
+  Converter: stream=0, channel=0
   PCM:
     rates [0x5e0]: 44100 48000 88200 96000 192000
     bits [0xe]: 16 20 24
     formats [0x1]: PCM
 Node 0x04 [Audio Output] wcaps 0x11: Stereo
-  Converter: stream=5, channel=4
+  Converter: stream=0, channel=0
   PCM:
     rates [0x5e0]: 44100 48000 88200 96000 192000
     bits [0xe]: 16 20 24
@@ -125,7 +127,7 @@
     bits [0xe]: 16 20 24
     formats [0x1]: PCM
 Node 0x06 [Audio Output] wcaps 0x211: Stereo Digital
-  Converter: stream=8, channel=0
+  Converter: stream=0, channel=0
   Digital: Enabled Non-Audio GenLevel
   Digital category: 0x2
   PCM:
@@ -138,7 +140,7 @@
   Device: name="ALC889 Analog", type="Audio", device=0
   Amp-In caps: ofs=0x10, nsteps=0x2e, stepsize=0x03, mute=1
   Amp-In vals:  [0x1c 0x1c]
-  Converter: stream=1, channel=0
+  Converter: stream=0, channel=0
   SDI-Select: 0
   PCM:
     rates [0x5e0]: 44100 48000 88200 96000 192000
@@ -186,13 +188,13 @@
   Connection: 1
      0x1f
 Node 0x0b [Audio Mixer] wcaps 0x20010b: Stereo Amp-In
-  Control: name="Mic Playback Volume", index=0, device=0
+  Control: name="Rear Mic Playback Volume", index=0, device=0
     ControlAmp: chs=3, dir=In, idx=0, ofs=0
-  Control: name="Mic Playback Switch", index=0, device=0
+  Control: name="Rear Mic Playback Switch", index=0, device=0
     ControlAmp: chs=3, dir=In, idx=0, ofs=0
-  Control: name="Front Mic Playback Volume", index=0, device=0
+  Control: name="Front Mic Playback Volume", index=1, device=0
     ControlAmp: chs=3, dir=In, idx=1, ofs=0
-  Control: name="Front Mic Playback Switch", index=0, device=0
+  Control: name="Front Mic Playback Switch", index=1, device=0
     ControlAmp: chs=3, dir=In, idx=1, ofs=0
   Control: name="Line Playback Volume", index=0, device=0
     ControlAmp: chs=3, dir=In, idx=2, ofs=0
@@ -253,7 +255,7 @@
   Control: name="IEC958 Playback Switch", index=0, device=0
   Control: name="IEC958 Default PCM Playback Switch", index=0, device=0
   Device: name="ALC889 Digital", type="SPDIF", device=1
-  Converter: stream=8, channel=0
+  Converter: stream=0, channel=0
   Digital: Enabled Non-Audio GenLevel
   Digital category: 0x2
   PCM:
@@ -281,7 +283,7 @@
   Amp-Out caps: ofs=0x00, nsteps=0x00, stepsize=0x00, mute=1
   Amp-Out vals:  [0x00 0x00]
   Pincap 0x0001003c: IN OUT HP EAPD Detect
-  EAPD 0x0:
+  EAPD 0x2: EAPD
   Pin Default 0x01014410: [Jack] Line Out at Ext Rear
     Conn = 1/8, Color = Green
     DefAssociation = 0x1, Sequence = 0x0
@@ -293,7 +295,7 @@
   Amp-Out caps: ofs=0x00, nsteps=0x00, stepsize=0x00, mute=1
   Amp-Out vals:  [0x00 0x00]
   Pincap 0x0001003c: IN OUT HP EAPD Detect
-  EAPD 0x0:
+  EAPD 0x2: EAPD
   Pin Default 0x01011012: [Jack] Line Out at Ext Rear
     Conn = 1/8, Color = Black
     DefAssociation = 0x1, Sequence = 0x2
@@ -325,7 +327,7 @@
   Connection: 5
      0x0c 0x0d 0x0e 0x0f* 0x26
 Node 0x18 [Pin Complex] wcaps 0x40018f: Stereo Amp-In Amp-Out
-  Control: name="Mic Boost", index=0, device=0
+  Control: name="Rear Mic Boost", index=0, device=0
     ControlAmp: chs=3, dir=In, idx=0, ofs=0
   Amp-In caps: ofs=0x00, nsteps=0x03, stepsize=0x27, mute=0
   Amp-In vals:  [0x00 0x00]
@@ -341,7 +343,7 @@
   Connection: 5
      0x0c 0x0d 0x0e 0x0f 0x26*
 Node 0x19 [Pin Complex] wcaps 0x40018f: Stereo Amp-In Amp-Out
-  Control: name="Front Mic Boost", index=0, device=0
+  Control: name="Front Mic Boost", index=1, device=0
     ControlAmp: chs=3, dir=In, idx=0, ofs=0
   Amp-In caps: ofs=0x00, nsteps=0x03, stepsize=0x27, mute=0
   Amp-In vals:  [0x00 0x00]
@@ -528,24 +530,50 @@
 --endcollapse--
 
 
+!!USB Mixer information
+!!---------------------------
+--startcollapse--
+
+USB Mixer: usb_id=0x046d0990, ctrlif=2, ctlerr=0
+Card: Logitech, Inc. QuickCam Pro 9000 at usb-0000:00:1a.0-1.1, high speed
+  Unit: 5
+    Control: name="Mic Capture Volume", index=0
+    Info: id=5, control=2, cmask=0x0, channels=1, type="S16"
+    Volume: min=4608, max=7680, dBmin=1800, dBmax=3000
+  Unit: 5
+    Control: name="Mic Capture Switch", index=0
+    Info: id=5, control=1, cmask=0x0, channels=1, type="INV_BOOLEAN"
+    Volume: min=0, max=1, dBmin=0, dBmax=0
+--endcollapse--
+
+
 !!ALSA Device nodes
 !!-----------------
 
-crw-rw---- 1 root audio 116, 10 Feb  7 18:46 /dev/snd/controlC0
-crw-rw---- 1 root audio 116,  9 Feb  7 18:46 /dev/snd/hwC0D0
-crw-rw---- 1 root audio 116,  8 Feb  7 18:46 /dev/snd/hwC0D3
-crw-rw---- 1 root audio 116,  7 Feb  7 18:46 /dev/snd/pcmC0D0c
-crw-rw---- 1 root audio 116,  6 Feb  8 07:40 /dev/snd/pcmC0D0p
-crw-rw---- 1 root audio 116,  5 Feb  7 19:43 /dev/snd/pcmC0D1p
-crw-rw---- 1 root audio 116,  4 Feb  7 18:46 /dev/snd/pcmC0D2c
-crw-rw---- 1 root audio 116,  3 Feb  7 18:46 /dev/snd/seq
-crw-rw---- 1 root audio 116,  2 Feb  7 18:46 /dev/snd/timer
+crw-rw---- 1 root audio 116, 10 Feb  8 07:52 /dev/snd/controlC0
+crw-rw---- 1 root audio 116, 12 Feb  8 07:52 /dev/snd/controlC1
+crw-rw---- 1 root audio 116,  9 Feb  8 07:52 /dev/snd/hwC0D0
+crw-rw---- 1 root audio 116,  8 Feb  8 07:52 /dev/snd/hwC0D3
+crw-rw---- 1 root audio 116,  7 Feb  8 07:52 /dev/snd/pcmC0D0c
+crw-rw---- 1 root audio 116,  6 Feb  8 07:52 /dev/snd/pcmC0D0p
+crw-rw---- 1 root audio 116,  5 Feb  8 07:52 /dev/snd/pcmC0D1p
+crw-rw---- 1 root audio 116,  4 Feb  8 07:52 /dev/snd/pcmC0D2c
+crw-rw---- 1 root audio 116, 11 Feb  8 07:52 /dev/snd/pcmC1D0c
+crw-rw---- 1 root audio 116,  3 Feb  8 07:52 /dev/snd/seq
+crw-rw---- 1 root audio 116,  2 Feb  8 07:52 /dev/snd/timer
+
+/dev/snd/by-id:
+total 0
+drwxr-xr-x 2 root root  60 Feb  8 07:52 .
+drwxr-xr-x 4 root root 300 Feb  8 07:52 ..
+lrwxrwxrwx 1 root root  12 Feb  8 07:52 usb-046d_0990_065B6718-02 -> ../controlC1
 
 /dev/snd/by-path:
 total 0
-drwxr-xr-x 2 root root  60 Feb  7 18:46 .
-drwxr-xr-x 3 root root 240 Feb  7 18:46 ..
-lrwxrwxrwx 1 root root  12 Feb  7 18:46 pci-0000:00:1b.0 -> ../controlC0
+drwxr-xr-x 2 root root  80 Feb  8 07:52 .
+drwxr-xr-x 4 root root 300 Feb  8 07:52 ..
+lrwxrwxrwx 1 root root  12 Feb  8 07:52 pci-0000:00:1a.0-usb-0:1.1:1.2 -> ../controlC1
+lrwxrwxrwx 1 root root  12 Feb  8 07:52 pci-0000:00:1b.0 -> ../controlC0
 
 
 !!ALSA configuration files
@@ -686,6 +714,9 @@
   Subdevices: 2/2
   Subdevice #0: subdevice #0
   Subdevice #1: subdevice #1
+card 1: Q9000 [QuickCam Pro 9000], device 0: USB Audio [USB Audio]
+  Subdevices: 1/1
+  Subdevice #0: subdevice #0
 
 !!Amixer output
 !!-------------
@@ -722,14 +753,14 @@
   Mono:
   Front Left: Playback 62 [97%] [0.00dB] [on]
   Front Right: Playback 62 [97%] [0.00dB] [on]
-Simple mixer control 'Front Mic',0
+Simple mixer control 'Front Mic',1
   Capabilities: pvolume pswitch penum
   Playback channels: Front Left - Front Right
   Limits: Playback 0 - 31
   Mono:
   Front Left: Playback 23 [74%] [0.00dB] [off]
   Front Right: Playback 23 [74%] [0.00dB] [off]
-Simple mixer control 'Front Mic Boost',0
+Simple mixer control 'Front Mic Boost',1
   Capabilities: volume penum
   Playback channels: Front Left - Front Right
   Capture channels: Front Left - Front Right
@@ -760,20 +791,6 @@
   Mono:
   Front Left: Playback 23 [74%] [0.00dB] [on]
   Front Right: Playback 23 [74%] [0.00dB] [on]
-Simple mixer control 'Mic',0
-  Capabilities: pvolume pswitch penum
-  Playback channels: Front Left - Front Right
-  Limits: Playback 0 - 31
-  Mono:
-  Front Left: Playback 23 [74%] [0.00dB] [off]
-  Front Right: Playback 23 [74%] [0.00dB] [off]
-Simple mixer control 'Mic Boost',0
-  Capabilities: volume penum
-  Playback channels: Front Left - Front Right
-  Capture channels: Front Left - Front Right
-  Limits: 0 - 3
-  Front Left: 0 [0%]
-  Front Right: 0 [0%]
 Simple mixer control 'IEC958',0
   Capabilities: pswitch pswitch-joined penum
   Playback channels: Mono
@@ -809,16 +826,30 @@
   Front Right: 255 [100%]
 Simple mixer control 'Input Source',0
   Capabilities: cenum
-  Items: 'Mic' 'Front Mic' 'Line'
-  Item0: 'Mic'
+  Items: 'Rear Mic' 'Front Mic' 'Line'
+  Item0: 'Rear Mic'
 Simple mixer control 'Input Source',1
   Capabilities: cenum
-  Items: 'Mic' 'Front Mic' 'Line'
-  Item0: 'Mic'
+  Items: 'Rear Mic' 'Front Mic' 'Line'
+  Item0: 'Rear Mic'
 Simple mixer control 'Input Source',2
   Capabilities: cenum
-  Items: 'Mic' 'Front Mic' 'Line'
-  Item0: 'Mic'
+  Items: 'Rear Mic' 'Front Mic' 'Line'
+  Item0: 'Rear Mic'
+Simple mixer control 'Rear Mic',0
+  Capabilities: pvolume pswitch penum
+  Playback channels: Front Left - Front Right
+  Limits: Playback 0 - 31
+  Mono:
+  Front Left: Playback 23 [74%] [0.00dB] [off]
+  Front Right: Playback 23 [74%] [0.00dB] [off]
+Simple mixer control 'Rear Mic Boost',0
+  Capabilities: volume penum
+  Playback channels: Front Left - Front Right
+  Capture channels: Front Left - Front Right
+  Limits: 0 - 3
+  Front Left: 0 [0%]
+  Front Right: 0 [0%]
 Simple mixer control 'Software',0
   Capabilities: volume penum
   Playback channels: Front Left - Front Right
@@ -834,6 +865,19 @@
   Front Left: 255 [100%]
   Front Right: 255 [100%]
 
+!!-------Mixer controls for card 1 [Q9000]
+
+Card hw:1 'Q9000'/'Logitech, Inc. QuickCam Pro 9000 at usb-0000:00:1a.0-1.1, high speed'
+  Mixer name	: 'USB Mixer'
+  Components	: 'USB046d:0990'
+  Controls      : 2
+  Simple ctrls  : 1
+Simple mixer control 'Mic',0
+  Capabilities: cvolume cvolume-joined cswitch cswitch-joined penum
+  Capture channels: Mono
+  Limits: Capture 0 - 3072
+  Mono: Capture 1536 [50%] [24.00dB] [on]
+
 
 !!Alsactl output
 !!-------------
@@ -937,7 +981,7 @@
 		comment.dbmin -3450
 		comment.dbmax 1200
 		iface MIXER
-		name 'Mic Playback Volume'
+		name 'Rear Mic Playback Volume'
 		value.0 23
 		value.1 23
 	}
@@ -946,7 +990,7 @@
 		comment.type BOOLEAN
 		comment.count 2
 		iface MIXER
-		name 'Mic Playback Switch'
+		name 'Rear Mic Playback Switch'
 		value.0 false
 		value.1 false
 	}
@@ -959,6 +1003,7 @@
 		comment.dbmax 1200
 		iface MIXER
 		name 'Front Mic Playback Volume'
+		index 1
 		value.0 23
 		value.1 23
 	}
@@ -968,6 +1013,7 @@
 		comment.count 2
 		iface MIXER
 		name 'Front Mic Playback Switch'
+		index 1
 		value.0 false
 		value.1 false
 	}
@@ -1000,7 +1046,7 @@
 		comment.dbmin 0
 		comment.dbmax 3000
 		iface MIXER
-		name 'Mic Boost'
+		name 'Rear Mic Boost'
 		value.0 0
 		value.1 0
 	}
@@ -1013,6 +1059,7 @@
 		comment.dbmax 3000
 		iface MIXER
 		name 'Front Mic Boost'
+		index 1
 		value.0 0
 		value.1 0
 	}
@@ -1087,36 +1134,36 @@
 		comment.access 'read write'
 		comment.type ENUMERATED
 		comment.count 1
-		comment.item.0 Mic
+		comment.item.0 'Rear Mic'
 		comment.item.1 'Front Mic'
 		comment.item.2 Line
 		iface MIXER
 		name 'Input Source'
-		value Mic
+		value 'Rear Mic'
 	}
 	control.25 {
 		comment.access 'read write'
 		comment.type ENUMERATED
 		comment.count 1
-		comment.item.0 Mic
+		comment.item.0 'Rear Mic'
 		comment.item.1 'Front Mic'
 		comment.item.2 Line
 		iface MIXER
 		name 'Input Source'
 		index 1
-		value Mic
+		value 'Rear Mic'
 	}
 	control.26 {
 		comment.access 'read write'
 		comment.type ENUMERATED
 		comment.count 1
-		comment.item.0 Mic
+		comment.item.0 'Rear Mic'
 		comment.item.1 'Front Mic'
 		comment.item.2 Line
 		iface MIXER
 		name 'Input Source'
 		index 2
-		value Mic
+		value 'Rear Mic'
 	}
 	control.27 {
 		comment.access read
@@ -1230,6 +1277,27 @@
 		value.1 255
 	}
 }
+state.Q9000 {
+	control.1 {
+		comment.access 'read write'
+		comment.type BOOLEAN
+		comment.count 1
+		iface MIXER
+		name 'Mic Capture Switch'
+		value true
+	}
+	control.2 {
+		comment.access 'read write'
+		comment.type INTEGER
+		comment.count 1
+		comment.range '0 - 3072'
+		comment.dbmin 1800
+		comment.dbmax 3000
+		iface MIXER
+		name 'Mic Capture Volume'
+		value 1536
+	}
+}
 --endcollapse--
 
 
@@ -1239,21 +1307,20 @@
 Module
 rfcomm
 fuse
-hidp
 bnep
 l2cap
 ftdi_sio
 usbserial
 uvcvideo
 videodev
-v4l1_compat
+snd_usb_audio
 snd_usbmidi_lib
 snd_rawmidi
+v4l1_compat
 coretemp
-thermal
-e1000e
-processor
 rt3572sta
+processor
+e1000e
 
 
 !!Sysfs Files
@@ -1304,9 +1371,5 @@
 ALSA device list:
   #0: HDA Intel at 0xf0420000 irq 22
 TCP cubic registered
---
-DeQueueRunning[0]= TRUE!
-hda-intel: IRQ timing workaround is activated for card #0. Suggest a bigger bdl_pos_adj.
-DeQueueRunning[0]= TRUE!
 
 